#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <sys/ipc.h> 
#include <sys/shm.h> 
 
#define     SHD_MEM_KEY         6905
 
/* parent control */
#define     PARENT_NORMAL           0
#define     PARENT_WAIT_DOWN        1
#define     PARENT_FORCE_DOWN       2
#define     PARENT_CHILD_RESTART    3

typedef struct {
    int     status;    /* θ μ  */
} process_info_t;

/*
* shared memory key  ȯ漳Ͽ о 
* ϴ  
*/
int g_shd_mem_key   = SHD_MEM_KEY;

process_info_t  *g_process_info;

void help(int argc, char *argv[])
{
    fprintf(stderr, "%s {-fdown | -wdown | -restart}\n", argv[0]);
    fprintf(stderr, "\tchild  process մϴ.\n\n");
    fprintf(stderr, "options\n");
    fprintf(stderr, "\t-fdown   : child process ó ٸ ʰ  \n");
    fprintf(stderr, "\t-wdown   : child process ó ٸ  \n");
    fprintf(stderr, "\t-restart : child process ó ٸ  child \n");
}

int main(int argc, char *argv[])
{
    int shmid;
    int mem_size;
    
    if(argc == 1) {
        help(argc, argv);
        return;
    }
    /* shared memory ٽ  */
    mem_size = sizeof(process_info_t);
    shmid = shmget((key_t)g_shd_mem_key, mem_size, 0600);
    if (shmid == -1) {
        perror("shmget failed : ");
        exit(0);
    }
 
    /*  shared memroy  */
    g_process_info = shmat(shmid, (void *)0, 0);
    if (g_process_info == (void *)-1) {
        perror("shmat failed : ");
        exit(0);
    }
    if(strcmp(argv[1], "-fdown") == 0) {
        g_process_info->status = PARENT_FORCE_DOWN;
    } else if(strcmp(argv[1], "-wdown") == 0) {
        g_process_info->status = PARENT_WAIT_DOWN;
    } else if(strcmp(argv[1], "-restart") == 0) {
        g_process_info->status = PARENT_CHILD_RESTART;
    } else {
        help(argc, argv);    
    }
    return 0;
}